/** 
 * @file iterativescan.h
 * @brief expand_seed function declaration
 */

#ifndef ITERATIVESCAN_H_
#define ITERATIVESCAN_H_

#include <algorithm>
#include <set>
#include <vector>
#include <utility>

#include "graph.h"
#include "seed.h"
#include "density.h"


/**
 * @fn std::pair<std::vector<seed>*, double> expand_seed(seed S);
 * @brief Adds neighbors of seed to increase density
 *
 * Explicitly copy S so we can change S without changing anything in the caller.
 * 
 * @param S Set of vertices to expand
 * 
 * @return Results - could be many seeds from disconnection
 */
std::pair<std::vector<seed>*, double> expand_seed(seed S);


#endif
