#include "Basic_structures.cpp"
#include <stdlib.h>

using namespace std;

void Constrained_Random_Data(vector<communication>& comms, speaker_list& slist){
    vector<int> speakers;
    vector<vector<int> > receivers;
    vector<double> intervals;
    int highest_receiver = 0;
    double initial_time = -1;
   //Runs through the list of communications and assembles speakers, intervals, and slist
    for(int i=0; i<comms.size(); i++){
        int sender = comms[i].speaker;
        int receiver = comms[i].listener;
        if(receiver > highest_receiver){highest_receiver = receiver;}
        double send_time = comms[i].time;
        speakers.push_back(sender);

        //Resizes receivers and adds new communication
        vector<int> d;
        while(receivers.size() <= sender){receivers.push_back(d);}
        receivers[sender].push_back(receiver);

        //adds interval to list of intervals
        if(initial_time != -1){intervals.push_back(send_time - initial_time);}
        initial_time = send_time;
    }

   //Assembles speaker_list based on random communications
    double current_time = 0;
    int last_speaker = -1;
    //seeded is a global bool from test_data.cpp which marks if rand has been seeded yet
    if(!seeded){seeded = true; srand(time(NULL));}
    for(int i=0; i<comms.size(); i++){

       //finds random time, speaker, and listener
        int new_speaker;
        double interval = intervals[rand() % intervals.size()];
        //when the interval is 0, we assume that a bulk message was sent by the same speaker
        if(interval == 0 && last_speaker != -1){new_speaker = last_speaker;}
        else{
            new_speaker = speakers[rand() % speakers.size()];
            last_speaker = new_speaker;
            current_time += interval;
        }
        int new_listener = receivers[new_speaker][rand() % receivers[new_speaker].size()];
        //cout << "slist: " << new_speaker << " " << new_listener << " " << current_time << endl;

       //resizes slist and adds new communication
        map<int, vector<double> > m;
        while(slist.size() <= new_speaker){slist.push_back(m);}
        map<int, vector<double> >::iterator map_itr = slist[new_speaker].find(new_listener);
        //if(map_itr == slist[new_speaker].end()){}
        slist[new_speaker][new_listener].push_back(current_time);
    }
    //This ensures that slist has slots dedicated to high-numbered actors
    // that only receive (don't send) communications
    map<int, vector<double> >m;
    while(slist.size() <= highest_receiver){slist.push_back(m);}

}
