#include <set>
#include "Hidden_Groups.cpp"

using namespace std;

//This function is used to find the weight of the edge between two triples
double Overlap_Factor(vector<pair<double, double> >* list1,  vector<pair<double, double> >* list2){
    double numer = min(list1 -> back().second, list2 -> back().second) - max(list1 -> front().first, list1 -> front().first);
    double denom = max(list1 -> back().second, list2 -> back().second) - min(list1 -> front().first, list2 -> front().first);
    return max(numer/denom, 0.0);
}

struct graph_edge {triple node1; triple node2; double weight;};

//Creates a complete graph with triples for nodes and their overlap for edges
set<graph_edge>* Weighted_Graph(triple_match_map* matching){
    set<graph_edge>* graph = new set<graph_edge>;
    triple_match_map::iterator itr = matching -> begin();
    graph_edge e;
    while(itr != matching -> end()){
        e.node1 = itr -> first;
        triple_match_map::iterator itr2 = matching -> begin();
        while(itr2 != itr){
            e.node2 = itr2 -> first;
            e.weight = Overlap_Factor(itr -> second, itr2 -> second);
            graph -> insert(e);
            itr2++;
        }
        itr++;
    }
    return graph;
}

bool operator< (const graph_edge& e1, const graph_edge& e2){
    if(e1.node1 < e2.node1){return true;}
    else if(!(e2.node1 < e1.node1) && (e1.node2 < e2.node2)){return true;} //ie, if e1.node1 == e2.node2 && e1.node2 < e2.node2
    return false;
}


void Write_Graph_To_File(set<graph_edge>* graph){
    set<graph_edge>::iterator itr = graph -> begin();
    ofstream out("temporary.txt");
    while(itr != graph -> end()){
        triple t = (*itr).node1;
        triple t2 = (*itr).node2;
        out << t.a << "." << t.b << "."  << t.c  << "." <<  t.chain << ", ";
        out << t2.a << "." << t2.b << "." << t2.c << "." << t.chain << ", ";
        out << itr -> weight << "\n";
        itr++;
    }
}
